#include <iostream>
#include <fstream>
#include <string>
#include <stdlib.h>

using namespace std;

int graphSize = 0;
float edgeDensity = 0;
string outFileName;

void printUsage() {
	cout << "usage: RandomGraph -s Size -d EdgeDensity -o OutputFileName" << endl;
}

void init_env(int argc, char** argv) {
	//initialize environment variable
	int opt = 0;
	while((opt=getopt(argc, argv, "s:d:o:"))!=EOF) {
		switch(opt) {
			case 'o': {outFileName = string(optarg); break;}
			case 's': {graphSize = atoi(optarg); break;}
			case 'd': {edgeDensity = atof(optarg); break;}
			default: break;
		}
	}
	if(outFileName.empty() || !graphSize || !edgeDensity){
		printUsage();
		exit(-1);
	}
}

int main(int argc, char **argv) {
	init_env(argc, argv);
	int i, j, k;
	short int **matrix = new short int* [graphSize];
	
	/*	initialization of the random graph	*/
	for(i = 0; i < graphSize; ++ i) {
		matrix[i] = new short int [graphSize];
		for(j = 0; j < graphSize; ++ j) {
			if(i == j) {
				matrix[i][j] == 0;
			} else {
				if(edgeDensity > 0.5) {
					matrix[i][j] = 1;
				} else {
					matrix[i][j] = 0;
				}
			}
		}
	}
	
	/*	computing the number of random positions to pick	*/
	long int topick = (long int) graphSize * (graphSize + 1) / 2;
	if(edgeDensity > 0.5) {
		topick = (long int) (topick * (1 - edgeDensity));
	} else {
		topick = (long int) (topick * edgeDensity);
	}
	/*	randomly picking edges	*/
	while(topick >= 0) {
		i = rand() % graphSize;
		j = rand() % graphSize;
		if(i == j) continue;
		else {
			if(edgeDensity > 0.5) {
				if(matrix[i][j] == 0) {
					continue;
				} else {
					matrix[i][j] = 0;
					matrix[j][i] = 0;
					-- topick;
				}
			} else {
				if(matrix[i][j] == 1) {
					continue;
				} else {
					matrix[i][j] = 1;
					matrix[j][i] = 1;
					-- topick;
				}
			}
		}
	}
	
	/*	outputing the generated graph	*/
	ofstream fout(outFileName.c_str());
	for(i = 0; i < graphSize; ++ i) {
		for(j = 0; j < graphSize; ++ j) {
			fout << matrix[i][j] << " ";
		}
		fout << endl;
	}
	fout.close();
	
	/*	clean up	*/
	for(i = 0; i < graphSize; ++ i) {
		delete [] matrix[i];
	}
	delete [] matrix;
	return 0;
}
