#include "graph.h"


using namespace std;

graph::graph(string filename, int n) {
	int i, j, k;
	/* set numVertices */
	numNodes = n;
	
	/* allocating memory */
	matrix = new int* [numNodes];
	adjCount = new int [numNodes];
	/* open file and read in values */
	int value;
	ifstream matrixFile(filename.c_str());
	/* for storing the adjacency nodes */
	int *tempElements = new int [n];
	int tempCount = 0;
	for(i = 0; i < numNodes; ++ i){
		tempCount = 0;
		/* reads in the graph */
		for(j = 0; j < numNodes; ++ j){
			matrixFile >> value;
			if(value == 1 && i != j){
				tempElements[tempCount ++] = j;
			}
			
		}
		/* copy into the public matrix */
		matrix[i] = new int [tempCount];
		for(j = 0; j < tempCount; ++ j) {
			matrix[i][j] = tempElements[j];
		}
		adjCount[i] = tempCount;
	}
	
	matrixFile.close();
	delete [] tempElements;
	return;
}

graph::~graph() {
	int i;
	for(i = 0; i < numNodes; ++ i) {
		delete [] matrix[i];
	}
	delete [] matrix;
	delete [] adjCount;
}

void graph::printMatrix() {
	int i, j;
	for(i = 0; i < numNodes; ++ i) {
		for(j = 0; j < adjCount[i]; ++ j) {
			cout << matrix[i][j] << " ";
		}
		cout << endl;
	}
}

int graph::binarySearch(int against, int key) {
	int i;
	int leftp = 0, midp, rightp = adjCount[against] - 1;
	if(key < matrix[against][0] || key > matrix[against][adjCount[against] - 1]) {
		return 0;
	}
	while(leftp <= rightp) {
		midp = (int) ((leftp + rightp) / 2);
		if(matrix[against][midp] == key) {
			return 1;
		}else {
			if(matrix[against][midp] < key) leftp = midp + 1; 
			else rightp = midp - 1;
		}
	}
	return 0;
}

int graph::connected(int i, int j) {
	if(i >= numNodes || j >= numNodes) cout << "Warnning: index out of range:	" << i << "|" << j << endl;
	if(i == j) return 1;
	if(adjCount[i] == 0 || adjCount[j] == 0) return 0;
	if(adjCount[i] <= adjCount[j])	return binarySearch(i, j);
	else		return binarySearch(j, i);
}
