#include "cstdlib"
#include "clique.h"

string filename;
int numofNodes = 0;
int cutoff = 1;
float coefficient = 0.4;
void printUsage() {
	cout << "usage: CLCL -i graph -n num_of_nodes [-c clique_size_cutoff] [-e connectivity_cutoff]" << endl;
}

void init_env(int argc, char** argv) {
	//initialize environment variable
	int opt = 0;
	while((opt=getopt(argc, argv, "i:n:c:e:"))!=EOF) {
		switch(opt) {
			case 'i': {filename = string(optarg); break;}
			case 'n': {numofNodes = atoi(optarg); break;}
			case 'c': {cutoff = atoi(optarg); break;}
			case 'e': {coefficient = atof(optarg); break;}
			default: break;
		}
	}
	if(filename.empty() || !numofNodes){
		printUsage();
		exit(-1);
	}
}

int main(int argc, char **argv) {
	init_env(argc, argv);
	clique testclique(filename, numofNodes);
	testclique.setCutoff(cutoff);
	testclique.setCoefficient(coefficient);
	testclique.findCliques();
	testclique.mergeNode();
	testclique.printCliques();
	return 0;
}
